
/* Revisione 42 - 8/7/1998 */

/* #define DOS */

 

#include <stdio.h>

#include <stdlib.h>

#include <math.h>

 

#ifdef DOS

#include <alloc.h> 

#else

#include <sys/time.h>

#endif

 

/* #define DEBUG */

/* #define CMEM */

 

#define PRECISIONE_DEF 0.001  /* Precisione di default per i metodi iterativi */

#define SIM_NOSS_DEF 10       /* Numero di osservazioni di default per la simulazione */

#define SIM_NITER_DEF 100000L /* Numero di iterazioni di default per la simulazione */

#define MAX_ITER 50           /* Numero massimo di iterazioni nei metodi AMVA-Core */

#define MAX_GCT 10            /* Numero massimo di iterazioni generali in AMVA-Linearizer */

#define MAX_GCT_RL 1500       /* Numero massimo di iterazioni nei metodi di carico ridotto */ 

#define MAX_EXPON 100000      /* Valore massimo effettivo delle distribuzioni esponenziali */ 

#define MAX_LINE_LEN 20000    /* Massima lunghezza di riga nel file di definizione rete */

#define MAX_DOUT_CELL 20      /* Massimo numero di celle per l'opzione -c */

 

typedef struct {

    int h;

    double *gamma;

    double *alfa;    /* [i][j] = [i * rete->a + j]   -- j = 0..a-1 */

    double *mu;

    double *xi;

    double *X;

    double *O;

    double *N;

} t_dati_classe;

 

typedef struct {

    int M, C, a;

    int *n;

    int *adiac;      /* [i][j] = [i * rete->a + j]   -- j = 0..a-1 */

    double *w_F;

    double *X;

    double *O;

    double *F;

    t_dati_classe *classe;

} t_rete;

 

typedef struct {

    double *X;

    double *O;

    double *N;

} t_incer_classe;

 

typedef struct {

    double *X;

    double *O;

    double *F;

    t_incer_classe *classe;

} t_incer;

 

typedef struct {

    long aa;

    long m;

    long b1, b2;

    double invmm2;

    long seme;

} t_random;

 

typedef double *tp_dblfar;

int mode = 0;

double precisione = PRECISIONE_DEF;

double prec_core = PRECISIONE_DEF;

long sim_niter = SIM_NITER_DEF;

int sim_noss = SIM_NOSS_DEF;

int amva_y = 2;

double dout_x = 0;

char dout_dir[100] = "./";

char dout_ext[5] = ".dat";

int dout_cell[MAX_DOUT_CELL+1];

 

#ifdef CMEM

long int memct = 0;

unsigned memcl = 11111;

unsigned long memfcl = 11111;

#endif

 

/* Topologie di rete predefinite */

int adiac_Q9[] = { 1,  3, -1, -1,

                   0,  4,  2, -1,

                   1,  5, -1, -1,

                   0,  4,  6, -1,

                   1,  3,  5,  7,

                   2,  4,  8, -1,

                   3,  7, -1, -1,

                   4,  6,  8, -1,

                   5,  7, -1, -1};

int adiac_2[] = {1, 0};

 

long int step_ct = 0;

 

 

#ifndef DOS

unsigned coreleft(void) {return 0;}

unsigned long farcoreleft(void) {return 0;}

#endif

 

 

void codifica_switch(char *s) {

 

    int i = 0;

    int j;

    char tmps[100];

    

    s[0] = '\0';    

    if (mode & 32) {

        if (mode & 1) {

            s[i++] = 'l';

            s[i] = '\0';

        } else {

            s[i++] = 'z';

            s[i] = '\0';

        }

    } else if ((mode & 3) == 0) {

        s[i++] = 'm';

        s[i] = '\0';

    } else if ((mode & 3) == 2) {

        s[i++] = 'a';

        s[i] = '\0';

    } else if ((mode & 3) == 1) {

        s[i++] = 's';

        s[i] = '\0';

    } else if ((mode & 3) == 3) {

        s[i++] = 'y';

        sprintf(tmps, "%d", amva_y);

        j = 0;

        while (tmps[j] != '\0') {

            s[i++] = tmps[j++];

        }    

        s[i] = '\0';

    }

    if (mode & 4) {

        s[i++] = 'v';

        s[i] = '\0';

    }

    if (mode & 16) {

        s[i++] = 'f';

        s[i] = '\0';

    }

    if (mode & 128) {

        s[i++] = 'r';

        s[i] = '\0';

    }

    if ((precisione != PRECISIONE_DEF) || (prec_core != PRECISIONE_DEF)) {

        s[i++] = 'p';

        sprintf(tmps, "%f", precisione);

        j = 0;

        while (tmps[j] != '\0') {

            s[i++] = tmps[j++];

        }    

        if (prec_core != precisione) {

            s[i++] = '.';

            sprintf(tmps, "%f", prec_core);

            j = 0;

            while (tmps[j] != '\0') {

                s[i++] = tmps[j++];

            }    

        }

        s[i] = '\0';

    }

    if (sim_noss != SIM_NOSS_DEF) {

        s[i++] = 'o';

        sprintf(tmps, "%d", sim_noss);

        j = 0;

        while (tmps[j] != '\0') {

            s[i++] = tmps[j++];

        }    

        s[i] = '\0';

    }

    if (sim_niter != SIM_NITER_DEF) {

        s[i++] = 'i';

        sprintf(tmps, "%d", sim_niter);

        j = 0;

        while (tmps[j] != '\0') {

            s[i++] = tmps[j++];

        }    

        s[i] = '\0';

    }

    

}

    

 

int leggi_switch(int argc, char **argv) {

 

    int i, j;

    int mode = 0;

 

    dout_cell[0] = -1;

    for(i=2; i<argc; i++) {

        if (argv[i][0] == '-') {

            switch(argv[i][1]) {

                case 's': mode |= 1;   /* MVA seriale */   /* Carico ridotto */

                          break;       /* AMVA multiplo */

                case 'a': mode |= 2;   /* MVA approssimato */

                          break;

                case 'v': mode |= 4;   /* Usa la correzione lineare sugli S in AMVA */

                          break;       /* Usa la gaussiana in AMVA multiplo */

                case 'p': if (argc > i+1) {   /* Indica la precisione delle approx */

                              if (isdigit(argv[i+1][0])) {

                                  precisione = atof(argv[++i]);

                                  prec_core = precisione;

                              }

                              if (argc > i+1) {

                                  if (isdigit(argv[i+1][0]))

                                      prec_core = atof(argv[++i]);

                                  

                              }    

                          }    

                          break;

                case 'd': mode |= 8;   /* Stampa la distribuzione dei pi in MVA */

                          break;

                case 'f': mode |= 16;  /* Stampa gli F in MVAp */

                          break;       /* Usa il seme fisso in simulazione */

                                       /* Forza la versione accelerata in AMVA trad. e mult. */

                case 'y': mode |= 3;   /* -y forza -a -s */

                          if (argc > i+1) {   /* Profondita' dell'AMVA lungo */

                              if (isdigit(argv[i+1][0])) {

                                  amva_y = atof(argv[i+1]);

                                  i++;

                              }

                          }    

                          break;

                case 'z': mode |= 32;  /* Simulazione (carico ridotto con -s) */

                          break;

                case 'l': mode |= 33;  /* Carico ridotto */

                          break;

                case 'o': if (argc > i+1) {   /* N.osservazioni in simulazione */

                              if (isdigit(argv[i+1][0])) {

                                  sim_noss = atoi(argv[i+1]);

                                  i++;

                              }

                          }

                          break;

                case 'i': if (argc > i+1) {   /* N.iterazioni in simulazione */

                              if (isdigit(argv[i+1][0])) {

                                  sim_niter = atol(argv[i+1]);

                                  i++;

                              }

                          }    

                          break;

                case 'm': mode |= 64;  /* Mostra le caratteristiche di rete */

                          break;

                case 'r': mode |= 128; /* Tratta le celle in ordine inverso */

                          break;

                case 'x': mode |= 256; /* Attiva output dati - specifica x */

                          if (argc > i+1) { 

                              if (isdigit(argv[i+1][0])) {

                                  dout_x = atof(argv[i+1]);

                                  i++;

                              }

                          }    

                          break;

                case 'n': if (argc > i+1) {   /* Dir. per output dati */

                              strcpy(dout_dir, argv[i+1]);

#ifdef DEBUG

                              printf("Data dir: %s\n", dout_dir);

#endif                              

                              i++;

                          }    

                          break;

                case 'c': j = 0;  /* Specifica le celle per cui fare l'output dati */

                          while ((argc > i+1) && (isdigit(argv[i+1][0])) && (j < MAX_DOUT_CELL)) {

                              dout_cell[j++] = atoi(argv[++i]);

                          }

                          dout_cell[j] = -1;

                          break;

         

            }

        }

    }

    return mode;

 

}

 

 

void dealloca_rete(t_rete *p_rete, t_incer *p_incer) {

 

    int c;

 

    if (p_rete == NULL) return;

    if (p_incer != NULL) {

        if (p_incer->classe != NULL) {

            for(c=0; c<p_rete->C; c++) {

                if (p_incer->classe[c].X != NULL) free(p_incer->classe[c].X);

                if (p_incer->classe[c].O != NULL) free(p_incer->classe[c].O);

                if (p_incer->classe[c].N != NULL) free(p_incer->classe[c].N);

            }

            free(p_incer->classe);

        }

        if (p_incer->X != NULL) free(p_incer->X);

        if (p_incer->O != NULL) free(p_incer->O);

        if (p_incer->F != NULL) free(p_incer->F);

        free(p_incer);

    }

    if (p_rete->classe != NULL) {

        for(c=0; c<p_rete->C; c++) {

            if (p_rete->classe[c].gamma != NULL) free(p_rete->classe[c].gamma);

            if (p_rete->classe[c].alfa != NULL) free(p_rete->classe[c].alfa);

            if (p_rete->classe[c].mu != NULL) free(p_rete->classe[c].mu);

            if (p_rete->classe[c].xi != NULL) free(p_rete->classe[c].xi);

            if (p_rete->classe[c].X != NULL) free(p_rete->classe[c].X);

            if (p_rete->classe[c].O != NULL) free(p_rete->classe[c].O);

            if (p_rete->classe[c].N != NULL) free(p_rete->classe[c].N);

        }

        free(p_rete->classe);

    }

    if (p_rete->w_F != NULL) free(p_rete->w_F);

    if (p_rete->X != NULL) free(p_rete->X);

    if (p_rete->O != NULL) free(p_rete->O);

    if (p_rete->F != NULL) free(p_rete->F);

    if (p_rete->adiac != NULL) free(p_rete->adiac);

    if (p_rete->n != NULL) free(p_rete->n);

 

    free(p_rete);

 

}

 

 

t_rete *alloca_rete(int M, int C, int a) {

 

/* Alloca la memoria per i dati di una nuova rete con m celle e c classi, e

   con a adiacenze massime tra celle. */

 

    size_t sz_dbl, sz_int;

    t_rete *nuova_rete;

    int c;

 

    sz_dbl = sizeof(double);

    sz_int = sizeof(int);

 

    nuova_rete = malloc(sizeof(t_rete));

    if (nuova_rete != NULL) {

#ifdef CMEM

        memct += sizeof(t_rete);

#endif

        nuova_rete->M = M;

        nuova_rete->C = C;

        nuova_rete->a = a;

        nuova_rete->n = (int *) malloc(M * sz_int);

        if (nuova_rete->n == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

        nuova_rete->adiac = (int *) malloc(M * a * sz_int);

        if (nuova_rete->adiac == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

        nuova_rete->w_F = (double *) malloc(M * sz_dbl);

        if (nuova_rete->w_F == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

        nuova_rete->X = (double *) malloc(M * sz_dbl);

        if (nuova_rete->X == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

        nuova_rete->O = (double *) malloc(M * sz_dbl);

        if (nuova_rete->O == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

        nuova_rete->F = (double *) malloc(M * sz_dbl);

        if (nuova_rete->F == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

#ifdef CMEM

        memct += 4 * M * sz_dbl + M * (1 + a) * sz_int;

#endif

        nuova_rete->classe = (t_dati_classe *) malloc(C * sizeof(t_dati_classe));

        if (nuova_rete->classe == NULL) {

            dealloca_rete(nuova_rete, NULL);

            return NULL;

        }

#ifdef CMEM

        memct += C * sizeof(t_dati_classe);

#endif

        for(c=0; c<C; c++) {

            nuova_rete->classe[c].gamma = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].alfa = (double *) malloc(M * a * sz_dbl);

            nuova_rete->classe[c].mu = (double *) malloc(M * sz_dbl);

            if ((nuova_rete->classe[c].gamma == NULL) || (nuova_rete->classe[c].alfa == NULL) || (nuova_rete->classe[c].mu == NULL)) {

                dealloca_rete(nuova_rete, NULL);

                return NULL;

            }

            nuova_rete->classe[c].xi = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].X = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].O = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].N = (double *) malloc(M * sz_dbl);

            if ((nuova_rete->classe[c].xi == NULL) || (nuova_rete->classe[c].X == NULL) || (nuova_rete->classe[c].O == NULL) || (nuova_rete->classe[c].N == NULL)) {

                dealloca_rete(nuova_rete, NULL);

                return NULL;

            }

#ifdef CMEM

            memct += (6+a) * M * sz_dbl;

#endif

        }

    }

    return nuova_rete;

 

}

 

 

t_incer *alloca_incer(t_rete *rete) {

 

    size_t sz_dbl;

    t_incer *nuova_rete;

    int c, C, M;

 

    M = rete->M;

    C = rete->C;

    sz_dbl = sizeof(double);

 

    nuova_rete = malloc(sizeof(t_incer));

    if (nuova_rete != NULL) {

#ifdef CMEM

        memct += sizeof(t_incer);

#endif

        nuova_rete->X = (double *) malloc(M * sz_dbl);

        if (nuova_rete->X == NULL) {

            dealloca_rete(rete, nuova_rete);

            return NULL;

        }

        nuova_rete->O = (double *) malloc(M * sz_dbl);

        if (nuova_rete->O == NULL) {

            dealloca_rete(rete, nuova_rete);

            return NULL;

        }

        nuova_rete->F = (double *) malloc(M * sz_dbl);

        if (nuova_rete->F == NULL) {

            dealloca_rete(rete, nuova_rete);

            return NULL;

        }

#ifdef CMEM

        memct += (3 * M) * sz_dbl;

#endif

        nuova_rete->classe = (t_incer_classe *) malloc(C * sizeof(t_incer_classe));

        if (nuova_rete->classe == NULL) {

            dealloca_rete(rete, nuova_rete);

            return NULL;

        }

#ifdef CMEM

        memct += C * sizeof(t_incer_classe);

#endif

        for(c=0; c<C; c++) {

            nuova_rete->classe[c].X = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].O = (double *) malloc(M * sz_dbl);

            nuova_rete->classe[c].N = (double *) malloc(M * sz_dbl);

            if ((nuova_rete->classe[c].X == NULL) || (nuova_rete->classe[c].O == NULL) || (nuova_rete->classe[c].N == NULL)) {

                dealloca_rete(rete, nuova_rete);

                return NULL;

            }

#ifdef CMEM

            memct += 3 * M * sz_dbl;

#endif

        }

    }

    return nuova_rete;

 

}

 

 

void crea_cella_predef(t_rete *rete, int i, int n, int modif) {

 

#define CLASSI_SINGOLE 1

#define BASSO_CARICO 2

 

    rete->n[i] = n;

    if (n > 10) {

        rete->classe[0].h = 1;

        rete->classe[0].gamma[i] = 10;

        rete->classe[0].mu[i] = (modif & BASSO_CARICO) ? 0.33 : 0.2;

        if (rete->C > 1) {

            rete->classe[1].h = (modif & CLASSI_SINGOLE) ? 1 : 2;

            rete->classe[1].gamma[i] = (modif & BASSO_CARICO) ? 10 : 50;

            rete->classe[1].mu[i] = 1;

        }

    } else {

        rete->classe[0].h = 1;

        rete->classe[0].gamma[i] = 1;

        rete->classe[0].mu[i] = 1;

        if (rete->C > 1) {

            rete->classe[1].h = (modif & CLASSI_SINGOLE) ? 1 : 2;

            rete->classe[1].gamma[i] = 2;

            rete->classe[1].mu[i] = 2;

        }

    }

    if (rete->C > 2) {

        rete->classe[2].h = (modif & CLASSI_SINGOLE) ? 1 : 4;

        rete->classe[2].gamma[i] = (modif & BASSO_CARICO) ? 1 : 10;

        rete->classe[2].mu[i] = 1;

    }

    if (rete->C > 3) {

        rete->classe[3].h = 1;

        rete->classe[3].gamma[i] = (modif & BASSO_CARICO) ? 2 : 10;

        rete->classe[3].mu[i] = 1;

    }

 

}

 

 

int crea_handover_bilanciato(t_rete *rete, double p0) {

 

/* Non e' necessario chiamarla se c'e' una sola cella */

 

    int nadiac;

    int i, j, ac, c;

 

    for(i=0; i<rete->M; i++) {

        nadiac = 0;

        ac = rete->adiac[i*rete->a];

        while ((ac > -1) && (nadiac < rete->a)) {

            nadiac++;

            ac = rete->adiac[i*rete->a + nadiac];

        }     

        j = 0;

        ac = rete->adiac[i*rete->a];

        while ((ac > -1) && (j < rete->a)) {

            for(c=0; c<rete->C; c++) {

                rete->classe[c].alfa[i*rete->a + j] = (1.0 - p0) / nadiac;

            }

            j++;

            ac = rete->adiac[i*rete->a + j];

        }

    }

 

    return 1;

 

}

 

 

t_rete *crea_rete_predef(int tipo) {

 

    int i;

    t_rete *rete;

 

    switch (tipo) {

        case 1: rete = alloca_rete(1, 1, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 3, 0);

                break;

        case 2: rete = alloca_rete(1, 2, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 4, 0);

                break;

        case 3: rete = alloca_rete(1, 2, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 100, 0);

                break;

        case 4: rete = alloca_rete(2, 1, 1);

                if (rete == NULL) return NULL;

                memcpy(rete->adiac, adiac_2, 2*sizeof(int));

                for(i=0; i<rete->M; i++) {

                    crea_cella_predef(rete, i, 2, 0);

                }

                if (! crea_handover_bilanciato(rete, 0.5)) return NULL;

                break;

        case 5: rete = alloca_rete(9, 2, 4);

                if (rete == NULL) return NULL;

                memcpy(rete->adiac, adiac_Q9, 36*sizeof(int));

                for(i=0; i<rete->M; i++) {

                    crea_cella_predef(rete, i, 100, 0);

                }

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

        case 6: rete = alloca_rete(100, 3, 2);

                if (rete == NULL) return NULL;

                for(i=0; i<rete->M; i++) {

                    rete->adiac[2*i] = i - 1;

                    rete->adiac[2*i+1] = i + 1;

                    crea_cella_predef(rete, i, 100, 0);

                }

                rete->adiac[0] = 1;

                rete->adiac[1] = -1;

                rete->adiac[199] = -1;

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

        case 7: rete = alloca_rete(200, 4, 2);

                if (rete == NULL) return NULL;

                for(i=0; i<rete->M; i++) {

                    rete->adiac[2*i] = i - 1;

                    rete->adiac[2*i+1] = i + 1;

                    crea_cella_predef(rete, i, 200, 0);

                }

                rete->adiac[0] = 1;

                rete->adiac[1] = -1;

                rete->adiac[399] = -1;

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

        case 8: rete = alloca_rete(1, 1, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 40, 0);

                break;

        case 9: rete = alloca_rete(9, 1, 4);

                if (rete == NULL) return NULL;

                memcpy(rete->adiac, adiac_Q9, 36*sizeof(int));

                for(i=0; i<rete->M; i++) {

                    crea_cella_predef(rete, i, 60, 0);

                }

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

       case 10: rete = alloca_rete(9, 2, 4);

                if (rete == NULL) return NULL;

                memcpy(rete->adiac, adiac_Q9, 36*sizeof(int));

                for(i=0; i<rete->M; i++) {

                    crea_cella_predef(rete, i, 60, CLASSI_SINGOLE);

                }

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

       case 11: rete = alloca_rete(2, 2, 1);

                if (rete == NULL) return NULL;

                memcpy(rete->adiac, adiac_2, 2*sizeof(int));

                for(i=0; i<rete->M; i++) {

                    crea_cella_predef(rete, i, 4, 0);

                }

                if (! crea_handover_bilanciato(rete, 0.5)) return NULL;

                break;

       case 12: rete = alloca_rete(100, 1, 2);

                if (rete == NULL) return NULL;

                for(i=0; i<rete->M; i++) {

                    rete->adiac[2*i] = i - 1;

                    rete->adiac[2*i+1] = i + 1;

                    crea_cella_predef(rete, i, 100, 0);

                }

                rete->adiac[0] = 1;

                rete->adiac[1] = -1;

                rete->adiac[199] = -1;

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

       case 13: rete = alloca_rete(100, 2, 2);

                if (rete == NULL) return NULL;

                for(i=0; i<rete->M; i++) {

                    rete->adiac[2*i] = i - 1;

                    rete->adiac[2*i+1] = i + 1;

                    crea_cella_predef(rete, i, 100, CLASSI_SINGOLE);

                }

                rete->adiac[0] = 1;

                rete->adiac[1] = -1;

                rete->adiac[199] = -1;

                if (! crea_handover_bilanciato(rete, 0.2)) return NULL;

                break;

       case 14: rete = alloca_rete(200, 4, 2);

                if (rete == NULL) return NULL;

                for(i=0; i<rete->M; i++) {

                    rete->adiac[2*i] = i - 1;

                    rete->adiac[2*i+1] = i + 1;

                    crea_cella_predef(rete, i, 200, BASSO_CARICO);

                }

                rete->adiac[0] = 1;

                rete->adiac[1] = -1;

                rete->adiac[399] = -1;

                if (! crea_handover_bilanciato(rete, 0.5)) return NULL;

                break;

       case 15: rete = alloca_rete(1, 1, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 70, 0);

                break;

       case 16: rete = alloca_rete(1, 1, 1);

                if (rete == NULL) return NULL;

                rete->adiac[0] = -1;

                crea_cella_predef(rete, 0, 30, 0);

                rete->classe[0].h = 3;

                break;

 

    }

 

    return rete;

 

}

 

 

int sscandouble(char **p_s, double *p_fv) {

 

    char sn[30];

    int i=0;

 

    if ((!isdigit(**p_s)) && (**p_s != '-')) {

        return 0;

    } else {

        if (**p_s == '-') {

           sn[i++] = '-';

           (*p_s)++;

        }

        while (isdigit(**p_s)) {

           sn[i++] = **p_s;

           (*p_s)++;

        }

        if ((**p_s) == '.') {

           sn[i++] = '.';

           (*p_s)++;

           while (isdigit(**p_s)) {

              sn[i++] = **p_s;

              (*p_s)++;

           }

        }

        sn[i] = '\0';

        while ((**p_s == ' ') || (**p_s == '\t')) {

           (*p_s)++;

        }

        *p_fv = atof(sn);

        return 1;

    }

 

}

 

 

int sscanint(char **p_s, int *p_v) {

 

    char sn[30];

    int i=0;

 

    if ((!isdigit(**p_s)) && (**p_s != '-')) {

        return 0;

    } else {

        if (**p_s == '-') {

           sn[i++] = '-';

           (*p_s)++;

        }

        while (isdigit(**p_s)) {

           sn[i++] = **p_s;

           (*p_s)++;

        }

        sn[i] = '\0';

        while ((**p_s == ' ') || (**p_s == '\t')) {

           (*p_s)++;

        }

        *p_v = atoi(sn);

        return 1;

    }

 

}

 

 

t_rete *err_lettura(t_rete *rete, FILE *fp) {

 

#ifdef DEBUG

    printf("Errore di lettura.\n");

#endif

    fclose(fp);

    dealloca_rete(rete, NULL);

    return NULL;

    

}

 

 

t_rete *leggi_rete(char *fname) {

 

    t_rete *rete;

    int M, C, a;

    int i, j, v, c;

    double fv;

    char s[MAX_LINE_LEN];

    char *p;

    FILE *fp;

    

    fp = fopen(fname, "r");

    if (fp == NULL)

        return NULL;    

 

    if (fscanf(fp, "%d %d %d\n", &M, &C, &a) < 3) {

        fclose(fp);

        return NULL;

    }

#ifdef DEBUG

    printf("Leggo la rete...\nM = %d, C = %d, a = %d\n", M, C, a);

#endif

    rete = alloca_rete(M, C, a);

 

    for(i=0; i<M; i++) {

        if (fgets(s, MAX_LINE_LEN, fp) == NULL)

            return err_lettura(rete, fp);

        j = 0;

        p = s;

        while (sscanint(&p, &v)) {

#ifdef DEBUG

            printf("adiac[%d][%d] = %d - avanza %s", i, j, v, p);

#endif

            rete->adiac[i*a+j] = v;

            j++;

        }

        while (j < a) {

            rete->adiac[i*a+j] = -1;

            j++;

        }

    }  

 

    if (fgets(s, MAX_LINE_LEN, fp) == NULL)

        return err_lettura(rete, fp);

    i = 0;

    p = s;

    while (sscanint(&p, &v)) {

#ifdef DEBUG

        printf("n[%d] = %d - avanza %s", i, v, p);

#endif

        rete->n[i] = v;

        i++;

    }

    while (i < M) {

        rete->n[i] = v;

#ifdef DEBUG

        printf("n[%d] = %d (per estensione)\n", i, v, p);

#endif

        i++;

    }

 

    for(c=0; c<C; c++) {

 

        if (!fscanf(fp, "%d\n", &v))

            return err_lettura(rete, fp);

        rete->classe[c].h = v;

#ifdef DEBUG

        printf("Dati per la classe %d\nh = %d\n", c, v);

#endif  

 

        if (fgets(s, MAX_LINE_LEN, fp) == NULL)

            return err_lettura(rete, fp);

        i = 0;

        p = s;    

        while (sscandouble(&p, &fv)) {

#ifdef DEBUG

            printf("gamma[%d] = %lf - avanza %s", i, fv, p);

#endif

            rete->classe[c].gamma[i] = fv;

            i++;

        }

        while (i < M) {

            rete->classe[c].gamma[i] = fv;

#ifdef DEBUG

            printf("gamma[%d] = %lf (per estensione)\n", i, fv);

#endif

            i++;

        }

 

        if (fgets(s, MAX_LINE_LEN, fp) == NULL)

            return err_lettura(rete, fp);

        i = 0;

        p = s;    

        while (sscandouble(&p, &fv)) {

#ifdef DEBUG

            printf("mu[%d] = %lf - avanza %s", i, fv, p);

#endif

            rete->classe[c].mu[i] = fv;

            i++;

        }

        while (i < M) {

            rete->classe[c].mu[i] = fv;

#ifdef DEBUG

            printf("mu[%d] = %lf (per estensione)\n", i, fv);

#endif

            i++;

        }

 

        for(i=0; i<M; i++) {

            if (fgets(s, MAX_LINE_LEN, fp) == NULL)

                return err_lettura(rete, fp);

            j = 0;

            p = s;

            while (sscandouble(&p, &fv)) {

#ifdef DEBUG

                printf("alfa[%d][%d] = %lf - avanza %s", i, j, fv, p);

#endif

                rete->classe[c].alfa[i*a+j] = fv;

                j++;

            }

            while (j < a) {

                rete->classe[c].alfa[i*a+j] = 0.0;

#ifdef DEBUG

                printf("alfa[%d][%d] = 0.0 (non ha altri confinanti?)\n", i, j, fv);

#endif

                j++;

            }

        }

    }

    

    fclose(fp);

#ifdef DEBUG    

    printf("\n\n");

#endif

    return rete;

 

}

 

 

void stampa_valori_cella(t_rete *rete, int i) {

 

    int c;

 

    printf("\n====== Cella numero %d ======\n\n", i);

    printf("Servitori: %4d - Numero medio di canali liberi: %4.2lf occupati: %4.2lf\n", rete->n[i], rete->F[i], (rete->n[i] - rete->F[i]));

    printf("Traffico medio smaltito: %4.2lf can/s - Traffico medio offerto: %4.2lf can/s\n", rete->X[i], rete->O[i]);

    printf("Probabilita' media di blocco: %2.6lf%%\n\n", 100 * (1 - rete->X[i] / rete->O[i]));

    for(c=0; c<rete->C; c++) {

        printf("Classe %3d: Numero medio di utenti %4.2lf - Probabilita' di blocco %2.6lf%%\n", c, rete->classe[c].N[i], 100 * (1 - rete->classe[c].X[i] / rete->classe[c].O[i]));

        printf("Traffico medio smaltito: %4.2lf ut/s - Traffico medio offerto: %4.2lf ut/s\n", rete->classe[c].X[i], rete->classe[c].O[i]);

    }

 

}

 

 

void stampa_valori_cella_incer(t_rete *rete, t_incer *incer, int i) {

 

    int c;

    double pi, ipi;

 

    printf("\n====== Cella numero %d ======\n\n", i);

    printf("Servitori: %4d - Numero medio di canali liberi: %4.2lf + %.2lf occupati: %4.2lf\n", rete->n[i], rete->F[i], incer->F[i], (rete->n[i] - rete->F[i]));

    printf("Traffico medio smaltito: %4.2lf + %.2lf c/s - offerto: %4.2lf + %.2lf c/s\n", rete->X[i], incer->X[i], rete->O[i], incer->O[i]);

    pi = 100 * (1 - rete->X[i] / rete->O[i]);

    ipi = (fabs(incer->X[i] / rete->X[i]) + fabs(incer->O[i] / rete->O[i])) * pi;

    printf("Probabilita' media di blocco: %2.6lf%% + %.6lf%%\n\n", pi, ipi);

    for(c=0; c<rete->C; c++) {

        pi = 100 * (1 - rete->classe[c].X[i] / rete->classe[c].O[i]);

        ipi = (fabs(incer->classe[c].X[i] / rete->classe[c].X[i]) + fabs(incer->classe[c].O[i] / rete->classe[c].O[i])) * pi;

        printf("Classe %3d: N. medio di ut. %4.2lf + %.2lf - P. di blocco %2.6lf%% + %.6lf%%\n", c, rete->classe[c].N[i], incer->classe[c].N[i], pi, ipi);

        printf("Traffico medio smaltito: %4.2lf + %.2lf ut/s - offerto: %4.2lf + %.2lf ut/s\n", rete->classe[c].X[i], incer->classe[c].X[i], rete->classe[c].O[i], incer->classe[c].O[i]);

    }

 

}

 

 

void stampa_valori(t_rete *rete, t_incer *incer) {

 

    int i;

 

    if (incer == NULL) {

        for(i=0; i<rete->M; i++) {

            stampa_valori_cella(rete, i);

        }

    } else {

        for(i=0; i<rete->M; i++) {

            stampa_valori_cella_incer(rete, incer, i);

        }

    }    

 

}

 

 

void scrivi_output_cella(t_rete *rete, t_incer *incer, char *switchs, int i) {

 

    int c;

    double pi, ipi; 

    char istr[10];

    char name[200];

    FILE *fp;

 

#ifdef DEBUG

    printf("Scrivo i file di output per la cella %d\n", i);

#endif    

 

    strcpy(name, dout_dir);

    sprintf(istr, "%d", i);

    strcat(name, istr);

    strcat(name, "-pb-");

    strcat(name, switchs);

    strcat(name, dout_ext);    

    fp = fopen(name, "a");

    if (fp != NULL) {

 

        pi = 100 * (1 - rete->X[i] / rete->O[i]);

        if (incer == NULL) {

            fprintf(fp, "%lf %lf\n", dout_x, pi);  

        } else {  

            ipi = (fabs(incer->X[i] / rete->X[i]) + fabs(incer->O[i] / rete->O[i])) * pi;

            fprintf(fp, "%lf %lf %.10f\n", dout_x, pi, ipi);  

        }

        fclose(fp);

        

    }        

 

    strcpy(name, dout_dir);

    sprintf(istr, "%d", i);

    strcat(name, istr);

    strcat(name, "-x-");

    strcat(name, switchs);

    strcat(name, dout_ext);    

    fp = fopen(name, "a");

    if (fp != NULL) {

 

        if (incer == NULL) {

            fprintf(fp, "%lf %lf\n", dout_x, rete->X[i]);  

        } else {  

            fprintf(fp, "%lf %lf %.10lf\n", dout_x, rete->X[i], incer->X[i]);  

        }

        fclose(fp);

        

    }        

 

    strcpy(name, dout_dir);

    sprintf(istr, "%d", i);

    strcat(name, istr);

    strcat(name, "-ox-");

    strcat(name, switchs);

    strcat(name, dout_ext);    

    fp = fopen(name, "a");

    if (fp != NULL) {

 

        if (incer == NULL) {

            fprintf(fp, "%lf %lf\n", dout_x, rete->O[i] - rete->X[i]);  

        } else {  

            pi = rete->O[i] - rete->X[i];

            fprintf(fp, "%lf %.10lf %.10lf\n", dout_x, pi, pi * (2 * incer->O[i] / rete->O[i] + incer->X[i] / rete->X[i]));  

        }

        fclose(fp);

        

    }        

 

    for(c=0; c<rete->C; c++) {

 

        strcpy(name, dout_dir);

        sprintf(istr, "%d", i);

        strcat(name, istr);

        strcat(name, "-");

        sprintf(istr, "%d", c);

        strcat(name, istr);

        strcat(name, "-pb-");

        strcat(name, switchs);

        strcat(name, dout_ext);    

        fp = fopen(name, "a");

        if (fp != NULL) {

 

            pi = 100 * (1 - rete->classe[c].X[i] / rete->classe[c].O[i]);

            if (incer == NULL) {

                fprintf(fp, "%lf %lf\n", dout_x, pi);  

            } else {  

                ipi = (fabs(incer->classe[c].X[i] / rete->classe[c].X[i]) + fabs(incer->classe[c].O[i] / rete->classe[c].O[i])) * pi;

                fprintf(fp, "%lf %lf %.10lf\n", dout_x, pi, ipi);  

            }

            fclose(fp);

            

        }        

 

        strcpy(name, dout_dir);

        sprintf(istr, "%d", i);

        strcat(name, istr);

        strcat(name, "-");

        sprintf(istr, "%d", c);

        strcat(name, istr);

        strcat(name, "-x-");

        strcat(name, switchs);

        strcat(name, dout_ext);    

        fp = fopen(name, "a");

        if (fp != NULL) {

 

            if (incer == NULL) {

                fprintf(fp, "%lf %lf\n", dout_x, rete->classe[c].X[i]);  

            } else {  

                fprintf(fp, "%lf %lf %.10lf\n", dout_x, rete->classe[c].X[i], incer->classe[c].X[i]); 

            }

            fclose(fp);

            

        }        

 

        strcpy(name, dout_dir);

        sprintf(istr, "%d", i);

        strcat(name, istr);

        strcat(name, "-");

        sprintf(istr, "%d", c);

        strcat(name, istr);

        strcat(name, "-ox-");

        strcat(name, switchs);

        strcat(name, dout_ext);    

        fp = fopen(name, "a");

        if (fp != NULL) {

 

            if (incer == NULL) {

                fprintf(fp, "%lf %.10lf\n", dout_x, rete->classe[c].O[i] - rete->classe[c].X[i]);  

            } else {  

                pi = rete->classe[c].O[i] - rete->classe[c].X[i];

                fprintf(fp, "%lf %.10lf %.10lf\n", dout_x, pi, pi * (2 * incer->classe[c].O[i] / rete->classe[c].O[i] + incer->classe[c].X[i] / rete->classe[c].X[i]));  

            }

            fclose(fp);

            

        }        

 

    }

 

}

 

 

void scrivi_output(t_rete *rete, t_incer *incer, char *switchs) {

 

    int i;

 

#ifdef DEBUG

    printf("Stampo l'output dati\n");

#endif    

   

    if (dout_cell[0] == -1) {   

        for(i=0; i<rete->M; i++) {

            scrivi_output_cella(rete, incer, switchs, i);

        }

    } else {

        i = 0;

        while ((dout_cell[i] > -1) && (i < MAX_DOUT_CELL)) {    

            if ((dout_cell[i] >= 0) && (dout_cell[i] < rete->M))

                scrivi_output_cella(rete, incer, switchs, dout_cell[i]);

            i++; 

        }

    }    

 

}

 

 

void scrivi_output_pt(double tc, double t, struct timeval *ts, char *switchs) {

 

    char name[200];

    FILE *fp;

    double te;

    

    strcpy(name, dout_dir);

    strcat(name, "p-");

    strcat(name, switchs);

    strcat(name, dout_ext);

    fp = fopen(name, "a");

    if (fp != NULL) {

        fprintf(fp, "%f %ld\n", dout_x, step_ct);

        fclose(fp);       

    } else

        return;

 

#ifndef DOS

    strcpy(name, dout_dir);

    strcat(name, "tc-");

    strcat(name, switchs);

    strcat(name, dout_ext);

    fp = fopen(name, "a");

    if (fp != NULL) {

        fprintf(fp, "%f %f\n", dout_x, tc);

        fclose(fp);       

    } else

        return;

 

    strcpy(name, dout_dir);

    strcat(name, "te-");

    strcat(name, switchs);

    strcat(name, dout_ext);

    fp = fopen(name, "a");

    if (fp != NULL) {

        te = ts->tv_sec + ( ((double) ts->tv_usec) / 1000000);

        fprintf(fp, "%f %f\n", dout_x, te);

        fclose(fp);       

    } else

        return;

 

    if (t) {         

        strcpy(name, dout_dir);

        strcat(name, "ts-");

        strcat(name, switchs);

        strcat(name, dout_ext);

        fp = fopen(name, "a");

        if (fp != NULL) {

            fprintf(fp, "%f %f\n", dout_x, t);

            fclose(fp);       

        } else

            return;

 

        strcpy(name, dout_dir);

        strcat(name, "tsr-");

        strcat(name, switchs);

        strcat(name, dout_ext);

        fp = fopen(name, "a");

        if (fp != NULL) {

            fprintf(fp, "%f %f\n", dout_x, tc / t);

            fclose(fp);       

        } else

            return;

    }

#endif

    

}    

     

 

void stampa_rete(t_rete *rete) {

 

    int i, c, j, k;

    double p;

    

    if (rete != NULL) {

        printf("\n******* Caratteristiche della rete ******\n");

        printf("\nRete di %d cell%c, con %d class%c di utenti.\n", rete->M, (rete->M == 1 ? 'a' : 'e'), rete->C, (rete->C == 1 ? 'e' : 'i'));

        if (rete->M > 1) {

            printf("Adiacenza massima pari a %d.\n", rete->a);

            for(i=0; i<rete->M; i++) {

                j = i * rete->a;

                k = (i+1) * rete->a;

                printf("Celle adiacenti alla %d:", i);

                while((rete->adiac[j] > -1) && (j < k)){

                    printf(" %d", rete->adiac[j++]);

                }

                printf("\n");

            }

        }

        for(i=0; i<rete->M; i++) {

            printf("\n====== Cella numero %d ======\n\n%d canali disponibili.\n", i, rete->n[i]);

            for(c=0; c<rete->C; c++) {

                printf("\nClasse %d : h = %d, velocita' di arrivo %.2lf, velocita' di servizio %.2lf\n", c, rete->classe[c].h, rete->classe[c].gamma[i], rete->classe[c].mu[i]);

                printf("Probabilita' di handover:\n");

                j = i * rete->a;

                k = (i+1) * rete->a;

                p = 0;

                while((rete->adiac[j] > -1) && (j < k)){

                    printf("Verso la cella %d: %.3lf\n", rete->adiac[j], rete->classe[c].alfa[j]);

                    p += rete->classe[c].alfa[j]; 

                    j++;

                }

                printf("Verso l'esterno (fine servizio): %.3lf\n", 1-p);

            }

        }

        printf("\nMemoria totale utilizzata dalla rete: %ld byte.\n", (long) ((4 + (6 + rete->a) * rete->C) * rete->M * sizeof(double) + rete->C * sizeof(t_dati_classe) + sizeof(t_rete) + (1 + rete->a) * rete->M * sizeof(int)) );    

    }

 

}     

 

 

int hmin(t_rete *rete) {

 

    int i, c;

 

    i = rete->classe[0].h;

    for(c=1; c<rete->C; c++) {

        if (rete->classe[c].h < i)

            i = rete->classe[c].h;

    }

    return i;

    

}

 

 

void mva_step_core(t_rete *rete, int i, double *X_prev, double *S) {

 

    int c, j, ac, k;

    double s, t, t0;

 

    s = 0;

    for(c=0; c<rete->C; c++) {

        t = rete->classe[c].gamma[i];

        j = 0;

        ac = rete->adiac[i*rete->a];

        if (X_prev == NULL) {

            while ((ac > -1) && (j < rete->a)) {

                k = ac * rete->a;

                while (rete->adiac[k] != i) {

                    k++;

                }

                t += rete->classe[c].alfa[k] * rete->classe[c].X[ac];

                j++;

                ac = rete->adiac[i*rete->a + j];

            }

        } else {

            while ((ac > -1) && (j < rete->a)) {

                k = ac * rete->a;

                while (rete->adiac[k] != i) {

                    k++;

                }

                t += rete->classe[c].alfa[k] * X_prev[ac*rete->C + c];

                j++;

                ac = rete->adiac[i*rete->a + j];

            }

        }

        rete->classe[c].O[i] = t;

        t *= S[c];

        if (c) {

            rete->classe[c].xi[i] = t / t0;

        } else {

            t0 = t;

            rete->classe[0].xi[i] = 1.0;

        }

        t /= 1 + rete->F[i];

        t *= rete->classe[c].h;

        s += t;

    }

    rete->w_F[i] = 1 / s;

    s = 0;

    t = 0;

    for(c=0; c<rete->C; c++) {

        t0 = rete->classe[c].h * rete->classe[c].xi[i];

        s += t0;

        t += t0 / rete->classe[c].mu[i];

    }

    rete->classe[0].X[i] = rete->n[i] / (s * rete->w_F[i] + t);

    rete->classe[0].N[i] = rete->classe[0].X[i] / rete->classe[0].mu[i];

    rete->O[i] = rete->classe[0].O[i] * rete->classe[0].h;

    for(c=1; c<rete->C; c++) {

        rete->classe[c].X[i] = rete->classe[0].X[i] * rete->classe[c].xi[i];

        rete->classe[c].N[i] = rete->classe[c].X[i] / rete->classe[c].mu[i];

        rete->O[i] += rete->classe[c].O[i] * rete->classe[c].h;

    }

    rete->X[i] = s * rete->classe[0].X[i];

    rete->F[i] = rete->X[i] * rete->w_F[i];

 

}

 

 

void mva_step_pi(t_rete *rete, int i, double *pi, double Fp) {

 

    int k;

 

    pi[rete->n[i]] = 1 - (rete->F[i] / (1 + Fp));

    for(k=0; k<rete->n[i]; k++) {

        pi[k] *= 1 - pi[rete->n[i]];

    }

 

}

 

 

void mva_step_S(t_rete *rete, int i, double *pi, double *S) {

 

/* Quando questa funzione viene chiamata, n[i] e' gia' stato incrementato */

 

    int c, k, fine;

 

    for(c=0; c<rete->C; c++) {

        S[c] = 1;

        fine = rete->n[i] - rete->classe[c].h;

        if (fine < -1)

            fine = -1;

        for(k = rete->n[i]-1; k > fine; k--) {

            S[c] -= pi[k];

        }

    }

 

}

 

 

int mva_init(t_rete *rete) {

 

/* Restituisce il numero del primo passo da cui partire, ossia min(h)-1 */

 

    int i, c;

 

    for(i=0; i<rete->M; i++) {

        rete->F[i] = 0;

        for(c=0; c<rete->C; c++) {

            rete->classe[c].X[i] = 0;

        }

    }

 

    return (hmin(rete) - 1);

 

}

 

 

void mva_step(t_rete *rete, int i, double *pi, double *S) {

 

    double Fp;

 

#ifdef DEBUG

    char ch;

    int lC;

 

    lC = rete->C - 1;

    if (! (rete->n[i] % 20)) {

        printf("?");

/*      ch = getchar(); */

        printf(" n    SL     xiL    wF     X1      F     piF   - Cella %d\n", i);

    }

#endif

    rete->n[i]++;

    step_ct++;

    Fp = rete->F[i];

    mva_step_S(rete, i, pi, S);

    mva_step_core(rete, i, NULL, S);

    mva_step_pi(rete, i, pi, Fp);

#ifdef DEBUG

    printf("%3d %1.4lf %1.4lf %1.4lf %1.4lf %1.4lf %1.4lf\n", rete->n[i], S[lC], rete->classe[lC].xi[i], rete->w_F[i], rete->classe[0].X[i], rete->F[i], pi[rete->n[i]]);

#endif

 

}

 

 

int mva_ser_cella(t_rete *rete, int i, int fstep) {

 

    int j, ntarget;

    double *S;

    double *pi;

 

    ntarget = rete->n[i];

    pi = (double*) malloc((ntarget + 1) * sizeof(double));

    if (pi == NULL) return 0;

    S = (double*) malloc(rete->C * sizeof(double));

    if (S == NULL) {

        free(pi);

        return 0;

    }

 

    rete->n[i] = fstep;

    pi[0] = 1;

    for(j = 1; j <= fstep; j++) {

        pi[j] = 0;

    }

#ifdef DEBUG

    printf("=== Cella %d ===\n", i);

#endif

    while (rete->n[i] < ntarget) {

        mva_step(rete, i, pi, S);

    }

 

    if (mode & 8) {

        printf("Distribuzione per la cella %d\n", i);

        for(j=0; j<=rete->n[i]; j++) {

            printf("Pi[%d] = %.10f\n", j, pi[j]);

        }

    }

 

    free(pi);

    free(S);

    return 1;

 

}

 

 

int mva_seriale(t_rete *rete) {

 

    int i, fstep;

 

    fstep = mva_init(rete);

    if (mode & 128) {

        i = rete->M - 1;

        while ((i >= 0) && (mva_ser_cella(rete, i, fstep))) {

        i--;

        }

        return (i == -1);

    } else {

        i = 0;

        while ((i < rete->M) && (mva_ser_cella(rete, i, fstep))) {

        i++;

        }

        return (i == rete->M);

    }

 

}

 

 

int mva_parallelo(t_rete *rete) {

 

    int i, j, fstep;

    tp_dblfar *v_pi;

    double *S;

    int *ntarget;

 

    fstep = mva_init(rete);

    ntarget = (int *) malloc(rete->M * sizeof(int));

    if (ntarget == NULL) return 0;

    S = (double*) malloc(rete->C * sizeof(double));

    if (S == NULL) {

        free(ntarget);

        return 0;

    }

    v_pi = (tp_dblfar *) malloc(rete->M * sizeof(tp_dblfar));

    if (v_pi == NULL) {

        free(ntarget);

        free(S);

        return 0;

    }

#ifdef CMEM

    memct += rete->M * sizeof(int) + rete->C * sizeof(double) + rete->M * sizeof(tp_dblfar);

#endif

    for(i=0; i<rete->M; i++) {

        v_pi[i] = (tp_dblfar) malloc((rete->n[i] + 1) * sizeof(double));

        if (v_pi[i] == NULL) {

#ifdef CMEM

            memcl = coreleft();

            memfcl = farcoreleft();

#endif

            for(j=0; j<i; j++) {

                free(v_pi[j]);

            }

            free(v_pi);

            free(ntarget);

            free(S);

            return 0;

        }

#ifdef CMEM

        memct += (rete->n[i] + 1) * sizeof(double);

#endif

        ntarget[i] = rete->n[i];

        rete->n[i] = fstep;

        v_pi[i][0] = 1;

        for(j = 1; j <= fstep; j++) {

            v_pi[i][j] = 0;

        }

    }

 

    if (mode & 128) {

        do {

            j = 0;

            for(i=rete->M-1; i>=0; i--) {

                if (rete->n[i] < ntarget[i]) {

                    mva_step(rete, i, v_pi[i], S);

                    if (mode & 16) {

                        printf("Cella %d, con %d servitori: stimo %f canali liberi.\n", i, rete->n[i], rete->F[i]);

                    }

                    j++;

                }

            }

        } while (j);

    } else {    

        do {

            j = 0;

            for(i=0; i<rete->M; i++) {

                if (rete->n[i] < ntarget[i]) {

                    mva_step(rete, i, v_pi[i], S);

                    if (mode & 16) {

                        printf("Cella %d, con %d servitori: stimo %f canali liberi.\n", i, rete->n[i], rete->F[i]);

                    }

                    j++;

                }

            }

        } while (j);

    }

 

    for(i=0; i<rete->M; i++) {

        if (mode & 8) {

            printf("Distribuzione per la cella %d\n", i);

            for(j=0; j<=rete->n[i]; j++) {

                printf("Pi[%d] = %.10f\n", j, v_pi[i][j]);

            }

        }

        free(v_pi[i]);

    }

    free(v_pi);

    free(ntarget);

    free(S);

    return 1;

 

}

 

 

void a_gauss(double *pi, int n, int x0) {

 

    int i;

    double sigma, c, ed;

    

    sigma = 0.15 * n;

    c = 0.3989423 / sigma;        /* const = 1/sqrt(2pi) */

    ed = -0.5 / (sigma * sigma);  /* const = 1/2sigma^2 */

    

    for(i=0; i<=n; i++) {

        pi[i] = c * exp(ed * (i - x0) * (i - x0));

    }

    

}

          

    

int amva_iter(t_rete *rete, double *F_delta, double *offset, double lim, int ii) {

 

/* L'unico parametro da inizializzare prima di questa funzione e' F[i] */

 

    double s;

    int i, j, c, ct, ac;

    double delta;

    double *X_prev;

    double *S_delta;

#ifdef DEBUG

    char ch;

#endif

 

    X_prev = malloc(rete->C * rete->M * sizeof(double));

    if (X_prev == NULL) return -1;

    S_delta = malloc(rete->C * rete->M * sizeof(double));

    if (S_delta == NULL) {

        free(X_prev);

        return -1;

    }

 

#ifdef DEBUG

    if (ii == -1)

        printf("AMVA - Iterazione con %d servitori alla cella 0\n", rete->n[0]);

    else

        printf("AMVA - Iterazione cella con %d servitori alla cella %d\n", rete->n[ii], ii);    

#endif    

    for(i=0; i<rete->M; i++) {

        F_delta[i] = (rete->n[i] - 1) * (rete->F[i] / rete->n[i] + offset[i]);

        for(c=0; c<rete->C; c++) {

            X_prev[i*rete->C + c] = (rete->n[i] - 1 - F_delta[i]) / (rete->C * rete->classe[c].mu[i] * rete->classe[c].h); 

            S_delta[i*rete->C + c] = (double) (1.0 + rete->n[i] - rete->classe[c].h) / rete->n[i];

        }

    }

 

    ct = 0;

#ifdef DEBUG

    if (! (ct % 20)) {

        printf("?");

/*      ch = getchar(); */

        printf("It   Xi    w_F    X1     Fi   Fdelta\n");

    }

#endif

    do {

        delta = 0;

        i = -1;

        do {

            if (ii >= 0)

                i = ii;

            else

                i++; 

#ifdef DEBUG

printf("Eseguo blocco AMVA per cella %d\n", i);

#endif

            s = rete->F[i];

            mva_step_core(rete, i, X_prev, &(S_delta[i*rete->C]) );

            step_ct++;

            if (fabs(rete->F[i] - s) > delta) delta = fabs(rete->F[i] - s);

            s = (1 + F_delta[i]) / s;

            F_delta[i] = (rete->n[i] - 1) * (rete->F[i] / rete->n[i] + offset[i]);

            s *= rete->F[i] / (1 + F_delta[i]);

            if (mode & 4) {

                for(c=0; c<rete->C; c++) {

                    if (rete->classe[c].h > 1)

                        S_delta[i*rete->C + c] *= 1 + 0.5 * (s - 1)*(rete->classe[c].h - 1);

                }

            } else {

                for(c=0; c<rete->C; c++) {

                    if (rete->classe[c].h > 1)

                        S_delta[i*rete->C + c] *= s;

                }

            }

        } while ((ii == -1) && (i < rete->M - 1));

        for(i=0; i<rete->M; i++) {

            for(c=0; c<rete->C; c++) {

                X_prev[i*rete->C + c] = rete->classe[c].X[i];

            }

        }

        ct++;

#ifdef DEBUG

        printf("%2d %2.5lf %1.4lf %1.4lf %1.4lf %1.4lf\n", ct, rete->classe[1].xi[0], rete->w_F[0], rete->classe[0].X[0], rete->F[0], F_delta[0]);

#endif

    } while (((delta > lim) || (ct < 2)) && (ct < MAX_ITER));

 

    free(X_prev);

    free(S_delta);

/*    free(F_delta); */

 

    return ct;

 

}

 

 

int amva(t_rete *rete, double lim, double lim_core) {

 

    double *offset, *cval, *F_delta;

    double delta;

    int i, j;

    int gct = 1;

 

    offset = malloc(rete->M * sizeof(double));

    if (offset == NULL) return -1;

    cval = malloc(3 * rete->M * sizeof(double));

    if (cval == NULL) {

        free(offset);

        return 0;

    }

    F_delta = malloc(rete->M * sizeof(double));

    if (F_delta == NULL) {

        free(cval);

        free(offset);

        return 0;

    }

    for(i=0; i<rete->M; i++) {

        cval[3*i] = (rete->n[i] - 1) / 2.0;

        cval[3*i + 1] = rete->n[i] / 2.0;

        offset[i] = 0;

    }

 

    do {

        for(i=0; i<rete->M; i++) {

            rete->F[i] = cval[3*i+1];

        }

        printf("Iterazione principale %d...\n", gct);

        amva_iter(rete, F_delta, offset, lim_core, -1);

        for(i=0; i<rete->M; i++) {

            cval[3*i+1] = rete->F[i];

            cval[3*i+2] = F_delta[i];

        }

        if (gct < MAX_GCT) {

            delta = 0;

            for(i=0; i<rete->M; i++) {

                if (rete->n[i] > 1) {

                    rete->n[i]--;

                    rete->F[i] = cval[3*i];

#ifdef DEBUG

                    printf("Iterazione secondaria %d per la cella %d con offset %lf\n", gct, i, offset[i]);

#endif      

                    if (mode & 16)

                        amva_iter(rete, F_delta, offset, lim_core, i);

                    else

                        amva_iter(rete, F_delta, offset, lim_core, -1);

                    cval[3*i] = rete->F[i];

                    if (fabs(cval[3*i] - cval[3*i+2]) > delta)

                        delta = fabs(cval[3*i] - cval[3*i+2]);

                    rete->n[i]++;

                } else {

                    cval[3*i] = 0;

                }

                offset[i] = cval[3*i] / (rete->n[i] - 1) - cval[3*i+1] / rete->n[i];

            }

        }

        gct++;

        printf("...terminata - Delta: %.6f\n", delta);

    } while ((gct <= MAX_GCT) && (delta > lim));

    if (delta < lim)

        gct--;

 

    free(offset);

    free(cval);

    free(F_delta);

    return gct;

 

}

 

 

int aymva_iter(t_rete *rete, int y, double *offset, double lim, int ii) {

 

/* L'unico parametro da inizializzare prima di questa funzione e' F[i] */

 

    double s;

    int i, j, c, ct, ac;

    double delta;

    double x0 = 0;

    double *S_delta, *F_delta;

    double *pi;

#ifdef DEBUG

    char ch;

#endif

 

    S_delta = malloc(rete->C * rete->M * sizeof(double));

    if (S_delta == NULL) {

        return -1;

    }

    F_delta = malloc(rete->M * sizeof(double));

    if (F_delta == NULL) {

        free(S_delta);

        return -1;

    }

 

    for(i=0; i<rete->M; i++) {

        F_delta[i] = (rete->n[i] - y) * (rete->F[i] / rete->n[i] + offset[i]);

        for(c=0; c<rete->C; c++) {

            rete->classe[c].X[i] = (rete->n[i] - y + 1 - F_delta[i]) / (rete->C * rete->classe[c].mu[i]);

        }

    }

 

    if (mode & 4)

        for(c=0; c<rete->C; c++) {

            x0 += rete->classe[c].gamma[0] / rete->classe[c].mu[0] * rete->classe[c].h;

        }

 

    ct = 0;

#ifdef DEBUG

    if (! (ct % 20)) {

        printf("?");

/*      ch = getchar(); */

        printf("It   Xi    w_F    X1     Fi   Fdelta\n");

    }

    if ((mode & 12) == 12) {

            printf("Mode %d\n", mode);

            pi = malloc((rete->n[0] + 1) * sizeof(double));

            a_gauss(pi, rete->n[0], x0);

            for(i=0; i<=rete->n[0]; i++) {

                printf("pi[%d] = %lf\n", i, pi[i]);

            }

            free(pi);

    }

#endif

 

    do {

        delta = 0;

        i = -1;

        do {

            if (ii >= 0)

                i = ii;

            else

                i++; 

#ifdef DEBUG

printf("Eseguo blocco AMVA multiplo per cella %d\n", i);

#endif

            pi = malloc((rete->n[i] + 1) * sizeof(double));

            s = rete->F[i];

            rete->n[i] -= y;

            rete->F[i] = F_delta[i];

            if (mode & 4) {

                a_gauss(pi, rete->n[i], x0);

            } else {

                for(j=0; j<=rete->n[i]; j++) {

                    pi[j] = 1.0 / (rete->n[i] + 1);

                }

            }

            for(j=0; j<y; j++) {

                mva_step(rete, i, pi, &(S_delta[i*rete->C]));

            }

            if (fabs(rete->F[i] - s) > delta)

                delta = fabs(rete->F[i] - s);

            F_delta[i] = (rete->n[i] - y) * (rete->F[i] / rete->n[i] + offset[i]);

            free(pi);

        } while ((ii == -1) && (i < rete->M - 1));

        ct++;

#ifdef DEBUG

        printf("%2d %2.5lf %1.4lf %1.4lf %1.4lf %1.4lf\n", ct, rete->classe[1].xi[0], rete->w_F[0], rete->classe[0].X[0], rete->F[0], F_delta[0]);

#endif

    } while (((delta > lim) || (ct < 2)) && (ct < MAX_ITER));

 

    free(S_delta);

    free(F_delta);

 

    return ct;

 

}

 

 

int aymva(t_rete *rete, double lim, double lim_core, int y) {

 

    double *hoffset, *cval;

    double delta, newoff;

    int i, j;

    int not_last, not_finished;

    int gct = 1;

 

    hoffset = malloc(rete->M * sizeof(double));

    if (hoffset == NULL) return -1;

    cval = malloc(2 * rete->M * sizeof(double));

    if (cval == NULL) {

        free(hoffset);

        return 0;

    }

    for(i=0; i<rete->M; i++) {

        cval[2*i] = (rete->n[i] - 1) / 2.0;

        cval[2*i + 1] = rete->n[i] / 2.0;

        hoffset[i] = 0;

    }

 

    j = hmin(rete);

    for(i=0; i<rete->M; i++) {

        if (y > rete->n[i] - j) {

            y = rete->n[i] - j;

            printf("Riduco la profondita' a %d perche' non ci sono abbastanza servitori alla coda %d.\n", rete->n[i] - j, i); 

        }

    }    

 

    delta = 0;

    not_finished = 1;

    do {

        for(i=0; i<rete->M; i++) {

            rete->F[i] = cval[2*i+1];

        }

        if (not_last) 

            printf("Iterazione principale %d...\n", gct);

        else

            printf("Iterazione conclusiva.\n");    

        aymva_iter(rete, y, hoffset, lim_core, -1);

        for(i=0; i<rete->M; i++) {

            cval[2*i+1] = rete->F[i];

        }

        if (not_last) {

            delta = 0;

            for(i=0; i<rete->M; i++) {

                if (rete->n[i] > 1) {

                    rete->n[i]--;

                    rete->F[i] = cval[2*i];

#ifdef DEBUG

                    printf("Iterazione secondaria %d per la cella %d\n", gct, i);

#endif      

                    if (mode & 16)

                        aymva_iter(rete, y, hoffset, lim_core, i);

                    else

                        aymva_iter(rete, y, hoffset, lim_core, -1);                    

                    cval[2*i] = rete->F[i];

                    rete->n[i]++;

                } else {

                    cval[2*i] = 0;

                }

                newoff = cval[2*i] / (rete->n[i] - 1) - cval[2*i+1] / rete->n[i];

                if (fabs(newoff - hoffset[i]) > delta)

                    delta = fabs(newoff - hoffset[i]);

                hoffset[i] = newoff;

#ifdef DEBUG

                printf("Offset cella %d = %lf\n", i, hoffset[i]);

#endif

            }

            printf("...terminata - Delta: %.6f\n", delta);

            gct++;

        } else

            not_finished = 0;

        not_last = ((delta > lim) && (gct < MAX_GCT));

    } while (not_finished);

    if (delta < lim)

        gct--;

 

    free(hoffset);

    free(cval);

    return gct;

 

}

 

 

double erlang_b(double n, double ro) {

 

    double r = 1;

    double s = 1;

    double f;

    int i;

    

    for(i=1; i<=n; i++) {

        r *= ro;

        r /= i;

        s += r;

    }

    r /= s;

    return r;

 

}  

 

 

void erlang_b_l(t_rete *rete, double *pi_b, int h_min, int i) {

 

/* Calcola le probabilita' di accettazione (1-pi_blocco) per le classi della cella i

   secondo Erlang-Lindberger */

 

    double ro_tot = 0;

    double h_med = 0;

    double pi_med;

    int c;

    double x;

    for(c=0; c<rete->C; c++) {

        pi_b[c] = rete->classe[c].O[i] / rete->classe[c].mu[i];

        x = pi_b[c] * rete->classe[c].h;

        ro_tot += x;

        x *= rete->classe[c].h;

        h_med += x;

    }

    h_med /= ro_tot;

    pi_med = erlang_b( (rete->n[i] - h_med + h_min) / h_med , ro_tot / h_med );

    for(c=0; c<rete->C; c++) {

        pi_b[c] = 1 - pi_med * rete->classe[c].h / h_med * pow(rete->n[i] / pi_b[c], 0.5 * (rete->classe[c].h / h_med - 1)); 

    }

 

}              

 

 

void erlang_b_rk(t_rete *rete, double *pi_b, int h_min, int i) {

 

    int m = 0;

    int n, f;

    double pi_tot = 0;

    int c;

    double *pi;

 

    n = rete->n[i];    

    pi = malloc((n + 1) * sizeof(double));

    if (pi == NULL)

        return;

 

    pi[0] = 1;

    while (m < n) {

        for(f=1; f<h_min; f++) {

            if (m < n)

                pi[++m] = 0;

        }

        if (m < n) {

            pi[++m] = 0;

            for(c=0; c<rete->C; c++) {

                if (m - rete->classe[c].h >= 0)

                    pi[m] += pi[m - rete->classe[c].h] * rete->classe[c].h * rete->classe[c].O[i] / rete->classe[c].mu[i];

            }

            pi[m] /= m;

            pi_tot += pi[m];

        }    

    }

    for(c=0; c<rete->C; c++) {

        pi_b[c] = pi_tot;

        f = rete->n[i] - rete->classe[c].h;

        if (f < -1)

            f = -1;

        for(m = n; m > f; m--) {

            pi_b[c] -= pi[m];

        }

        pi_b[c] /= pi_tot;  /* normalizzazione */

    }

    

    free(pi);

      

}    

      

 

int carico_ridotto(t_rete *rete, double lim) {

 

    int h_min;

    double *pi;

    double *O_next;

    int i, c, j, k, m, ac;

    int gct = 0;

    double t, delta;

    

    pi = malloc(rete->M * rete->C * sizeof(double));

    if (pi == NULL) {

        return 0;

    }

    O_next = malloc(rete->M * rete->C * sizeof(double));

    if (O_next == NULL) {

        free(pi);

        return 0;

    }

    

    h_min = hmin(rete);

    for(i=0; i<rete->M; i++) {

        for(c=0; c<rete->C; c++) {

            rete->classe[c].O[i] = rete->classe[c].gamma[i];

        }

    }

    

    do {

        if (mode & 4) {

            for(i=0; i<rete->M; i++) {

                erlang_b_l(rete, &(pi[i * rete->C]), h_min, i);

            }

        } else {

            for(i=0; i<rete->M; i++) {

                erlang_b_rk(rete, &(pi[i * rete->C]), h_min, i);

            }

        }    

        delta = 0;

        m = 0;

        for(i=0; i<rete->M; i++) {

            for(c=0; c<rete->C; c++) {

                O_next[m] = rete->classe[c].gamma[i];

                j = 0;

                ac = rete->adiac[i*rete->a];

                while ((ac > -1) && (j < rete->a)) {

                    k = ac * rete->a;

                    while (rete->adiac[k] != i) {

                        k++;

                    }

                    O_next[m] += rete->classe[c].alfa[k] * rete->classe[c].O[ac] * pi[ac * rete->C + c];

                    j++;

                    ac = rete->adiac[i*rete->a + j];

                }

                t = fabs(rete->classe[c].O[i] - O_next[m]);

                if (t > delta)

                    delta = t;

                m++;

            }

        }

        step_ct++;

        gct++;

#ifdef DEBUG

        printf("Iterazione %d completata - Delta: %.30lf\n", gct, delta);

#endif

        m = 0;

        for(i=0; i<rete->M; i++) {

            for(c=0; c<rete->C; c++) {

                rete->classe[c].O[i] = O_next[m++];

            }

        }

    } while ((delta > lim) && (gct < MAX_GCT_RL));

 

    if (gct < MAX_GCT_RL) {

        printf("Convergenza raggiunta in %d iterazioni.\n", gct); 

    } else {

        printf("Convergenza non raggiunta.\n", gct); 

    }    

    m = 0;

    for(i=0; i<rete->M; i++) {

        rete->O[i] = 0;

        rete->X[i] = 0;

        rete->F[i] = rete->n[i];

        for(c=0; c<rete->C; c++) {

            rete->classe[c].X[i] = O_next[m] * pi[m];

            rete->classe[c].N[i] = rete->classe[c].X[i] / rete->classe[c].mu[i];

            rete->O[i] += O_next[m] * rete->classe[c].h;

            rete->X[i] += rete->classe[c].X[i] * rete->classe[c].h;

            rete->F[i] -= rete->classe[c].N[i];

            m++;

        }

    }

    

    free(pi);

    free(O_next);

    return 1;

    

}    

        

   

long power(int base, int esp) {

 

    long t = 1;

    int i;

    

    for(i=0; i<esp; i++) {

        t *= base;

    }

    return t;

    

}

 

 

t_random *init_random(long seme) {

 

/* initialization of the pseudo-random sequence generator

   THE FOLLOWING CODE TAKES CARE OF OVERFLOW AVOIDANCE

   ON 32-bit SIGNED INTEGER ARITHMETICS */

        

    long m, b1, b2;    

    t_random *rs;

#ifndef DOS

    struct timeval t;

#endif

 

    rs = malloc(sizeof(t_random));

    if (rs == NULL)

        return NULL;

 

#ifdef DOS

    rs->seme = seme;

#else

    if (seme) 

        rs->seme = seme;

    else {

        gettimeofday(&t, NULL);

        rs->seme = t.tv_usec;

    }

#endif        

    

    rs->aa = power(7, 5);

    m = power(2, 30);

    m = m - 1;

    m = m + m + 1;      /*  m = 2**31-1  */

    b1 = m / rs->aa;

    b2 = (rs->aa * b1) % m;

    b1 = b1 + 1;        /*  b1 = (m div aa)+1  */

    b2 = b2 - m;

    b2 = b2 + rs->aa;       /*  b2 = ((aa * b1) mod m)  */

    rs->invmm2 = 1.0 / (m - 2);

    rs->m = m;

    rs->b1 = b1;

    rs->b2 = b2;

 

    return rs;

    

}

        

        

double rnd(t_random *rs) {                                        

                                        

/* pseudo-random sequence generator */

                                          

    long x, x1, x2;

    long x2a, y, seme;

                                            

    seme = rs->seme;

    x1 = seme / rs->b1;

    x2 = seme % rs->b1;

    y = rs->m - x1 * rs->b2;

    x2a = x2 * rs->aa;

    if (y < x2a)

        x = x2a - y;

    else

        x = x1 * rs->b2 + x2a;

    rs->seme = x;

    return ( (x - 1) * rs->invmm2 );

    

}

                                                                    

                                                                    

double expon(t_random *rs, double lambda) {

 

    double stoc;

                                                                         

    stoc = rnd(rs);

    if ((stoc > 0) && (stoc < 1))

         return ( -(log(stoc)) / lambda);

    else

         return MAX_EXPON;

 

}

 

 

int init_simula(t_rete *rete, double **p_tr, double **p_tt, double **p_N) {

 

    int i, c;

    double *tt, *tr;

    double *N;

    

    tt = malloc(rete->C * rete->M * sizeof(double));

    if (tt == NULL) {

        return 0;

    }

    tr = malloc(rete->C * rete->M * sizeof(double));

    if (tr == NULL) {

        free(tt);

        return 0;

    }

    N = malloc(rete->C * rete->M * sizeof(double));

    if (N == NULL) {

        free(tt);

        free(tr);

        return 0;

    }    

    

    for(i=0; i<rete->C * rete->M; i++) {

        tt[i] = 0;

        tr[i] = 0;

        N[i] = 0;

    }

    

    (*p_tr) = tr;

    (*p_tt) = tt;

    (*p_N) = N;

    return 1; 

    

}

                                                                     

 

void simula_arrivo(t_rete *rete, int i, int c, double *tt, double *tr) {

 

    if ((i < 0) || (i >= rete->M) || (c < 0) || (c >= rete->C)) {

        printf("i = %d c = %d\n", i, c);

        exit(1);

    }

    tt[i * rete->C + c]++;

    if (rete->F[i] >= rete->classe[c].h) {

        rete->F[i] -= rete->classe[c].h;

        rete->classe[c].xi[i]++;

        tr[i * rete->C + c]++;

    }

 

}

 

 

void simula_risultati(double *r, double *i, double **v_r, int j, int n_oss) {

 

    int k;

    double x;

    

    (*r) = 0;

    for(k=0; k<n_oss; k++) {

        (*r) += v_r[k][j];

    }

    (*r) /= n_oss;

    (*i) = 0;

    for(k=0; k<n_oss; k++) {

        x = (v_r[k][j]-(*r));

        x *= x;

        (*i) += x;

    }

    (*i) = 1.96 * sqrt((*i) / (n_oss - 1)) / sqrt(n_oss);

    

}     

 

 

double simulazione(t_rete *rete, t_incer *incer, long max_iter, int n_oss) {

 

/* Attenzione: qui, e solo qui, alcune variabili di rete vengono usate con

   significato diverso:

   

   rete->classe[c].xi[i]  utenti in servizio in ogni istante

   rete->F[i]             canali disponibili in ogni istante (e non numero

                          medio)

 

Accumulatori

 

   N[i,c]                 accumulatore di utenza (N * tpe)

   tt[i,c]                accumulatore dei tentativi totali di ingresso

   tr[i,c]                accumulatore dei tentativi riusciti di ingresso

 

*/

 

    double tpe; /* tempo mancante al prossimo evento */

    double randt;

    int ipe;    /* coda del prossimo evento */

    int cpe;    /* classe del prossimo evento */

    int ype;    /* tipo del prossimo evento (0 = arrivo, 1 = partenza) */

    double t;   /* tempo del sistema */

    t_random *rs;

    double *tt, *tr;

    double *N;

    double **v_tt, **v_tr;

    double **v_N;

    double *v_t;

    long z;

    int i, j, k;

    int c, ac;

 

#ifdef DOS

    rs = init_random(1711);

#else    

    if (mode & 16) {

        rs = init_random(1711);

    } else {

        rs = init_random(0);

    }

#endif    

    if (rs == NULL)

        return 0;

    v_tt = malloc(n_oss * sizeof(double*));

    if (v_tt == NULL) {

        free(rs); 

        return 0;

    }

    v_tr = malloc(n_oss * sizeof(double*));

    if (v_tr == NULL) {

        free(rs);

        free(v_tt); 

        return 0;

    }

    v_N = malloc(n_oss * sizeof(double*));

    if (v_N == NULL) {

        free(rs);

        free(v_tt); 

        free(v_tr);

        return 0;

    }

    v_t = malloc(n_oss * sizeof(double));

    if (v_t == NULL) {

        free(rs);

        free(v_tt); 

        free(v_tr);

        free(v_N);

        return 0;

    }

 

    for(i=0; i<rete->M; i++) {

        rete->F[i] = rete->n[i];

        for(c=0; c<rete->C; c++) {

            rete->classe[c].xi[i] = 0;

        }

    }

 

    for(k=0; k<n_oss; k++) {

        printf("\nOsservazione %d...\n", k+1);

        if (!init_simula(rete, &tr, &tt, &N)) {

            free(rs);

            free(v_tt); 

            free(v_tr);

            free(v_N);

            free(v_t);  

            return 0;

        }

        v_tr[k] = tr;

        v_tt[k] = tt;

        v_N[k] = N;

        t = 0;

        for(z=0; z<max_iter; z++) {

 

            tpe = MAX_EXPON;

            for(i=0; i<rete->M; i++) {

                for(c=0; c<rete->C; c++) {

                    randt = expon(rs, rete->classe[c].gamma[i]);

                    if (randt < tpe) {

                        tpe = randt;

                        ipe = i;

                        cpe = c;

                        ype = 0;

                    }

                    if (rete->classe[c].xi[i] > 0) {

                        randt = expon(rs, rete->classe[c].mu[i] * rete->classe[c].xi[i]);

                        if (randt < tpe) {

                            tpe = randt;

                            ipe = i;

                            cpe = c;

                            ype = 1;

                        }

                    }    

                }

            }    

#ifdef DEBUG

            if (!(z % 1000))

                printf("Iterazione %ld - Tempo %lf - Ultimo evento (%lf, %d, %d, %d)\n", z, t, tpe, ipe, cpe, ype);

#endif

            j = 0;

            for(i=0; i<rete->M; i++) {

                for(c=0; c<rete->C; c++) {

                    N[j++] += tpe * rete->classe[c].xi[i]; /* accumulatore utenza media */

                }

            }

            t += tpe;

            if (ype) {

                rete->classe[cpe].xi[ipe]--;

                rete->F[ipe] += rete->classe[cpe].h;

                randt = rnd(rs);

                j = 0;

                ac = rete->adiac[rete->a * ipe + j];

                while ((ac > -1) && (j < rete->a) && (randt > rete->classe[cpe].alfa[rete->a * ipe + j])) {

                    randt -= rete->classe[cpe].alfa[rete->a * ipe + j];

                    j++;

                    ac = rete->adiac[rete->a * ipe + j];

                }

                if ((ac > -1) && (j < rete->a))

                    simula_arrivo(rete, ac, cpe, tt, tr);

            } else

                simula_arrivo(rete, ipe, cpe, tt, tr);

 

        }

        printf("...terminata - Periodo simulato %.3lf s.\n", t);

 

        for(j=0; j<rete->M * rete->C; j++) {

            N[j] /= t;

            tr[j] /= t;

            tt[j] /= t;

        }    

        v_t[k] = t;

                  

        step_ct += max_iter;    

    }

 

    j = 0;

    for(i=0; i<rete->M; i++) {

        for(c=0; c<rete->C; c++) {

#ifdef DEBUG

            printf("Calcolo risultati per cella %d, classe %d\n", i, c);

#endif            

            simula_risultati(&(rete->classe[c].N[i]), &(incer->classe[c].N[i]), v_N, j, n_oss);

            simula_risultati(&(rete->classe[c].X[i]), &(incer->classe[c].X[i]), v_tr, j, n_oss);

            simula_risultati(&(rete->classe[c].O[i]), &(incer->classe[c].O[i]), v_tt, j, n_oss);

            j++;

        }

        rete->F[i] = rete->n[i];

        rete->X[i] = 0;

        rete->O[i] = 0;

        incer->F[i] = 0;

        incer->X[i] = 0;

        incer->O[i] = 0;

        for(c=0; c<rete->C; c++) {

            rete->F[i] -= rete->classe[c].N[i];

            rete->X[i] += rete->classe[c].X[i] * rete->classe[c].h;

            rete->O[i] += rete->classe[c].O[i] * rete->classe[c].h;

            incer->F[i] += incer->classe[c].N[i];

            incer->X[i] += incer->classe[c].X[i] * rete->classe[c].h;

            incer->O[i] += incer->classe[c].O[i] * rete->classe[c].h;

        }

    }

 

#ifdef DEBUG

            printf("Dealloco la memoria delle osservazioni\n");

#endif            

    t = 0;

    for(k=0; k<n_oss; k++) {        

        t += v_t[k];

        free(v_tr[k]);

        free(v_tt[k]);

        free(v_N[k]);

    }

    t /= n_oss;

#ifdef DEBUG

            printf("Dealloco la memoria della simulazione\n");

#endif            

    free(v_t);

    free(v_tr);

    free(v_tt);

    free(v_N);

    free(rs);

    return t;

 

}

 

 

#ifndef DOS

void dftvtime(struct timeval *t1, struct timeval *t2) {

 

    t2->tv_sec -= t1->tv_sec;

    t2->tv_usec -= t1->tv_usec;

    if (t2->tv_usec < 0) {

        t2->tv_sec--;

        t2->tv_usec += 1000000;

    }

    

}         

#endif

 

 

void main(int argc, char **argv) {

 

    t_rete *rete;

    t_incer *incer = NULL;

    int i;

    double t = 0;

    char switchs[100];

#ifndef DOS

    double tc;

    struct timeval timeval1, timeval2;

    clock_t cput1, cput2;

#endif

 

    if (argc > 1) {

        if (argc > 2)

            mode = leggi_switch(argc, argv);

        if (isdigit(argv[1][0])) {

            i = atoi(argv[1]);

            rete = crea_rete_predef(i);

        } else {

            rete = leggi_rete(argv[1]);

        }

    } else

        rete = crea_rete_predef(1);    

 

    if (rete != NULL) {

        if (mode & 64)

            stampa_rete(rete);

#ifndef DOS

        gettimeofday(&timeval1, NULL);

        cput1 = clock();

#endif

        printf("\n****** Analisi ******\n"); 

        if (mode & 32) {

            if (mode & 1) {

                if (mode & 4) 

                    printf("Metodo di carico ridotto con formula di Erlang-Lindberger.\n");

                else

                    printf("Metodo di carico ridotto con formula di Erlang-Roberts-Kaufman.\n");

                i = carico_ridotto(rete, precisione);

            } else {

                if (sim_noss < 2) {

                    sim_noss = 2;

                    printf("Aumento il numero di osservazioni al minimo di 2.\n");

                }

                printf("Simulazione - Batch means con %d osservazioni da %ld iterazioni.\n", sim_noss, sim_niter);

                incer = alloca_incer(rete);

                if (incer != NULL) {

                    t = simulazione(rete, incer, sim_niter, sim_noss);

                    i = (t ? 1 : 0);

                } else

                    i = 0;

            }

        } else if (mode & 2) {

            if (mode & 1) {

               printf("MVA approssimato multiplo - Precisioni %lf e %lf, lunghezza %d\n", precisione, prec_core, amva_y);

               i = aymva(rete, precisione, prec_core, amva_y);

            } else {

               printf("MVA approssimato - Precisioni %lf e %lf\n", precisione, prec_core);

               i = amva(rete, precisione, prec_core);

            }

            if (i == MAX_GCT)

               printf("Convergenza non raggiunta.\n");

            else

               printf("Convergenza raggiunta in %d iterazioni generali.\n", i);

        } else if (mode & 1) {

            printf("MVA in modalita' seriale.\n");

            i = mva_seriale(rete);

        } else {

            printf("MVA in modalita' parallela.\n");

            i = mva_parallelo(rete);

        }

#ifndef DOS

        cput2 = clock();

        gettimeofday(&timeval2, NULL);

#endif

        printf("\n****** Risultati ******\n");

        if (i) {

            stampa_valori(rete, incer);

            if (mode & 256) {

                codifica_switch(switchs);           

                scrivi_output(rete, incer, switchs);

            }    

#ifdef CMEM

            printf("\nByte allocati: %ld", memct);

#endif

        } else {

            printf("\nERRORE - Impossibile allocare la memoria per l'esecuzione.");

#ifdef CMEM

            printf("\nByte allocati: %ld - Liberi: %u - Far liberi: %lu", memct, memcl, memfcl);

#endif

        }

#ifdef DEBUG

        printf("Sto per deallocare la rete.\n");

#endif

        dealloca_rete(rete, incer);

        if (t) {

            printf("\nFine. %ld passi di simulazione complessivi.\n", step_ct);

        } else {

            printf("\nFine. %ld passi di iterazione complessivi.\n", step_ct);

        }

#ifndef DOS

        dftvtime(&timeval1, &timeval2);

        tc = (((double) (cput2 - cput1)) / CLOCKS_PER_SEC); 

        printf("Tempo di calcolo: %.2lf s - Tempo di esecuzione: %ld.%04ld s\n", tc, timeval2.tv_sec, 

timeval2.tv_usec / 100);

        if (mode & 256)

            scrivi_output_pt(tc, t, &timeval2, switchs);

        if (t) {

            tc /= t;

            if (tc < 1) {

                tc = 1 / tc;

                printf("Tempo medio simulato: %.2lf s - Rapporto tempo virtuale/reale: %.1lf/1\n", t, tc);

            } else {    

                printf("Tempo medio simulato: %.2lf s - Rapporto tempo virtuale/reale: 1/%.1lf\n", t, tc);

            }

        }

#endif    

        printf("\n");

    } else {

        printf("Impossibile leggere la rete o allocare la relativa memoria.\n\n");

    }

 

}
